/******************************** CPPFile *****************************

* FileName [LvalueCollector.cpp]

* PackageName [main]

* Synopsis [Method definitions of LvalueCollector class.]

* SeeAlso [LvalueCollector.h]

* Author [Sagar Chaki]

* Copyright [ Copyright (c) 2002 by Carnegie Mellon University. All
* Rights Reserved. This software is for educational purposes only.
* Permission is given to academic institutions to use, copy, and
* modify this software and its documentation provided that this
* introductory message is not removed, that this software and its
* documentation is used for the institutions' internal research and
* educational purposes, and that no monies are exchanged. No guarantee
* is expressed or implied by the distribution of this code. Send
* bug-reports and/or questions to: chaki+@cs.cmu.edu. ]

**********************************************************************/

#include <cassert>
#include <string>
#include <list>
#include <set>
#include <vector>
#include <map>
using namespace std;

#include "Util.h"
#include "Node.h"
#include "DFSAdapter.h"
#include "LvalueCollector.h"

/*********************************************************************/
//overridden methods
/*********************************************************************/
void LvalueCollector::outIdExpr(const IdExpr &node)
{
  lvalues.insert(node.id);
}

void LvalueCollector::outDotExpr(const DotExpr &node)
{
  lvalues.insert(Util::TrimString(node.ToString()));
}

void LvalueCollector::outArrowExpr(const ArrowExpr &node)
{
  lvalues.insert(Util::TrimString(node.ToString()));
}

/*********************************************************************/
//end of LvalueCollector.cpp
/*********************************************************************/
