/**************************** CPPHeaderFile ***************************

* FileName [LvalueCollector.h]

* PackageName [main]

* Synopsis [Header file for LvalueCollector class.]

* Description [This class encapsulates a AST walker that computes the
* set of lvalues in an expression.]

* SeeAlso [LvalueCollector.cpp]

* Author [Sagar Chaki]

* Copyright [ Copyright (c) 2002 by Carnegie Mellon University.  All
* Rights Reserved. This software is for educational purposes only.
* Permission is given to academic institutions to use, copy, and
* modify this software and its documentation provided that this
* introductory message is not removed, that this software and its
* documentation is used for the institutions' internal research and
* educational purposes, and that no monies are exchanged. No guarantee
* is expressed or implied by the distribution of this code. Send
* bug-reports and/or questions to: chaki+@cs.cmu.edu. ]

**********************************************************************/

#ifndef __LVALUECOLLECTOR_H__
#define __LVALUECOLLECTOR_H__

//other classes needed
class IdExpr;
class DotExpr;
class ArrowExpr;

class LvalueCollector : public DFSAdapter
{
 private:
  set<string> lvalues;
 public:
  LvalueCollector() {}
  LvalueCollector(const LvalueCollector &rhs) { lvalues = rhs.lvalues; }
  virtual ~LvalueCollector() {}
  
  set<string> GetLvalues() const { return lvalues; }

  //overridden methods
  void outIdExpr(const IdExpr &node);
  void outDotExpr(const DotExpr &node);
  void outArrowExpr(const ArrowExpr &node);
};

#endif //__LVALUECOLLECTOR_H__

/*********************************************************************/
//end of LvalueCollector.h
/*********************************************************************/
