/**************************** CPPHeaderFile ***************************

* FileName [Statistics.h]

* PackageName [main]

* Synopsis [Header file for Statistics class.]

* Description [This class encapsulates various statistics collected
* during the execution of the tool.]

* SeeAlso [Statistics.cpp]

* Author [Sagar Chaki]

* Copyright [ Copyright (c) 2002 by Carnegie Mellon University.  All
* Rights Reserved. This software is for educational purposes only.
* Permission is given to academic institutions to use, copy, and
* modify this software and its documentation provided that this
* introductory message is not removed, that this software and its
* documentation is used for the institutions' internal research and
* educational purposes, and that no monies are exchanged. No guarantee
* is expressed or implied by the distribution of this code. Send
* bug-reports and/or questions to: chaki+@cs.cmu.edu. ]

**********************************************************************/

#ifndef __STATISTICS_H__
#define __STATISTICS_H__

class Statistics
{
 public:
  static double startTime;
  static double endTime;
  static size_t elimCombNum;
  static size_t maxElimCombNum;
  static size_t maxElimCombSize;
  static size_t maxTriedCombSize;
  static int seedNum;
  static int stateNum;
  static int iterNum;
  static int predIterNum;
  static int ltsIterNum;
  static int tpCalls;
  static int tpInCache;
  static int tpCacheSize;  
  
  Statistics() {}
  static void Display();
};

#endif //__STATISTICS_H__

/*********************************************************************/
//end of Statistics.h
/*********************************************************************/
